// CertificateInfo.h: interface for the CCertificateInfo class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CERTIFICATEINFO_H__D4B21E51_90AD_11D3_80E0_00A0C9E2EA8A__INCLUDED_)
#define AFX_CERTIFICATEINFO_H__D4B21E51_90AD_11D3_80E0_00A0C9E2EA8A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include <iostream>
#include "VString.h"
#include "Certificate.h"
#include "DLLDefs.h"

class __exportVTKC CCertificateInfo
{
	friend void CCertificate::GetCertInfo(const CContext& context, CCertificateInfo& certInfo) const;

private:
	// Temporary (until necessary functions from Toolkit are provided)
	// make copy constructor and assign operator not available
	CCertificateInfo(const CCertificateInfo& obj);
	CCertificateInfo& operator=(const CCertificateInfo& obj);

public:

	CCertificateInfo();
	virtual ~CCertificateInfo();

	// Accessors to Info Data
	long Version() const;
	VString SerialNum() const;
	VString SignatureAlg() const;
	VString Issuer() const;
	time_t NotBefore() const;
	time_t NotAfter() const;
	VString Subject() const;
	VString PublicKeyAlg() const;
	VString IssuerUniqueId() const;
	VString SubjectUniqueId() const;


protected:

	// Structure that details of the certificate
	Vtk_CertInfo *m_pCertInfo;
};


__exportVTKC ostream& operator<<(ostream& os, const CCertificateInfo& obj);


#endif // !defined(AFX_CERTIFICATEINFO_H__D4B21E51_90AD_11D3_80E0_00A0C9E2EA8A__INCLUDED_)
