// CertificateStore.h: interface for the CCertificateStore class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CERTIFICATESTORE_H__A03B0F6F_6719_11D3_80B3_00A0C9E2EA8A__INCLUDED_)
#define AFX_CERTIFICATESTORE_H__A03B0F6F_6719_11D3_80B3_00A0C9E2EA8A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "DLLDefs.h"
#include <vtk_defs.h>

class CCertificate;
class CContext;
class VString;

class __exportVTKC CCertificateStore  
{
private:

	// Temporary (until necessary functions from Toolkit are provided)
	// make copy constructor and assign operator not available
	CCertificateStore(const CCertificateStore& obj);
	CCertificateStore& operator=(const CCertificateStore& obj);

public:
	CCertificateStore();
	CCertificateStore(const CContext& context);
	CCertificateStore(const CContext& context, const VString& fileName, 
		              enum Vtk_DataFormat format);

	virtual ~CCertificateStore();

	// Get certificate store structure
	const Vtk_CertStore* GetVtkCertStore() const {return this->m_pCertStore;};

	// Adding individual certificate to the store
	void AddCertificate(const CContext& context, const CCertificate& cert);
	void AddCertificate(const CContext& context, const unsigned char *pSource, int size,
		                enum Vtk_DataFormat format);

//	void AddCertificate(const CContext& context, const Vtk_Buffer *pSource);



protected:

	// Structure that contains list of  X.509 certificates
	Vtk_CertStore *m_pCertStore;


};

#endif // !defined(AFX_CERTIFICATESTORE_H__A03B0F6F_6719_11D3_80B3_00A0C9E2EA8A__INCLUDED_)
