// ProtocolDetails.h: interface for the CProtocolDetails class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PROTOCOLDETAILS_H__6539D3E4_9C88_11D3_80E8_00A0C9E2EA8A__INCLUDED_)
#define AFX_PROTOCOLDETAILS_H__6539D3E4_9C88_11D3_80E8_00A0C9E2EA8A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ValQueries.h"
#include <vtk_defs.h>

class __exportVTKC CProtocolDetails  
{
	friend void CValQueries::ProtocolDetails(int nIndex, CProtocolDetails& detailsOut) const;

public:
	CProtocolDetails();
	virtual ~CProtocolDetails();

	// Accessors and Mutators
	///////////////////////////////

	// Possible values: 	VTK_VM_CRT, VTK_VM_OCSP, VTK_VM_CRL
	enum Vtk_ValidationMech ValidationMech() const {return m_details.type;};
	void ValidationMech(enum Vtk_ValidationMech mech) {m_details.type = mech;};

	// Possible values: VTK_DF_STRING, VTK_DF_DER, VTK_DF_BASE64, VTK_DF_HEX
	enum Vtk_DataFormat DataFormat() const {return m_details.d.crl.encoding;};
	void DataFormat(enum Vtk_DataFormat format) {m_details.d.crl.encoding = format;};

	// Possible values:  VTK_DT_CRL, VTK_DT_PKCS7
	enum Vtk_DataType DataType() const {return m_details.d.crl.type;};
	void DataType(enum Vtk_DataType type) {m_details.d.crl.type = type;};



	const Vtk_ProtocolDetails& GetVtkDetails() const {return m_details;};

protected:

	// Vtk structure representing protocol details
	Vtk_ProtocolDetails m_details;

};

#endif // !defined(AFX_PROTOCOLDETAILS_H__6539D3E4_9C88_11D3_80E8_00A0C9E2EA8A__INCLUDED_)
