// ValQueries.h: interface for the CValQueries class.
//
//////////////////////////////////////////////////////////////////////
//
// Individual validation query information. Application can obtain 
// individaul query information in order to perform its own retrieval 
// of the information from the VA.
//

#if !defined(AFX_VALQUERIES_H__98CB56F7_9DFA_11D3_80E9_00A0C9E2EA8A__INCLUDED_)
#define AFX_VALQUERIES_H__98CB56F7_9DFA_11D3_80E9_00A0C9E2EA8A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <vector>
#include "VString.h"
#include "Validator.h"

class CProtocolDetails;

class __exportVTKC CValQueries  
{

	// Following friends are only function that can set Vtk_ValQuery data
	friend void CValidator::GetQueries(const CContext& context, CValQueries& valQueries) const;
	friend void CValidator::ValidateFromQueries(const CContext& context, CValQueries& valQueries,
							Vtk_uint32 *pStatus, VString *pStrStatus);


private:

	// Temporary (until necessary functions from Toolkit are provided)
	// make copy constructor and assign operator not available
	CValQueries(const CValQueries& obj);
	CValQueries& operator=(const CValQueries& obj);


public:
	CValQueries();
	virtual ~CValQueries();


	// Check if structure Vtk_ValQuery was initialized
	bool IsNull() const { return m_ppQuery == NULL ? true : false; }

	// Accessors for 
	int Size() const;
	enum Vtk_ValidationMech ValidationMech(int nIndex) const;
	VString Host(int nIndex) const;
	int Port(int nIndex) const;
	VString Url(int nIndex) const;
	void ProtocolDetails(int nIndex, CProtocolDetails& detailsOut) const;
	void Request(int nIndex, vector<unsigned char>& requestOut) const;
	void GetResponse(int nIndex, vector<unsigned char>& responseOut) const;

	// Setting response in Vtk_ValQuery, so the response can be validated
	void SetResponse(int nIndex, const vector<unsigned char>& responseIn);
	void SetResponse(int nIndex, const unsigned char* pResponse, int responseSize);


protected:

	int m_size;
	Vtk_ValQuery **m_ppQuery;


};

#endif // !defined(AFX_VALQUERIES_H__98CB56F7_9DFA_11D3_80E9_00A0C9E2EA8A__INCLUDED_)
